<?php

namespace App\Http\Controllers\Api\Admin;

use App\Http\Controllers\Controller;
use App\Models\Bot;
use App\Models\Operation;
use App\Models\User;
use Illuminate\Http\JsonResponse;

class HomeController extends Controller
{
    public function index(): JsonResponse
    {
        return response()->json([
            'ok' => true,
            'data' => [
                'bots' => Bot::query()->get(),
                'customer_count' => User::role('customer')->count(),
                'operations_count' => Operation::query()->count(),
            ]
        ]);
    }
}
