<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

;

use Illuminate\Support\MessageBag;

class AuthController extends Controller
{
    public function authorize(Request $request): JsonResponse
    {
        $errors = new MessageBag();

        if (!Auth::validate([
            'username' => $request->post('login'),
            'password' => $request->post('password')
        ]))
            $errors = new MessageBag([
                'login' => 'نام کاربری یا گذرواژه صحیح نمیباشد.'
            ]);

        if ($errors->isEmpty()) {
            $user = User::query()->firstWhere('username',
                $request->post('login'));
            $user['roles'] = $user->getRoleNames();

            return response()->json([
                'ok' => true,
                'data' => $user->jwt(true)
            ]);
        } else {
            return response()->json([
                'ok' => false,
                'errors' => $errors
            ], 400);
        }
    }

    public function ping(): JsonResponse
    {
        $user = Auth::user();
        $user['roles'] = $user->getRoleNames();
        return response()->json([
            'ok' => true,
            'data' => $user->jwt()
        ]);
    }
}
