<?php

namespace App\Http\Controllers\Api\Customer;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\JsonResponse;

class HomeController extends Controller
{
    public function index(): JsonResponse
    {
        /** @var User $user */
        $user = auth()->user();
        return response()->json([
            'ok' => true,
            'data' => [
                'bots_count' => $user->bots()->count(),
                'channels_count' => $user->channels()->count(),
                'operations_count' => $user->operations()->count(),
            ]
        ]);
    }
}
