<?php

namespace App\Http\Controllers;

use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\MessageBag;

class HomeController extends Controller
{
    public function index(): JsonResponse
    {
        return response()->json([
            'ok' => true
        ]);
    }

    public function test(Request $request): JsonResponse
    {
        $inputs = $request->only(['login', 'password']);

        $errors = Validator::make($inputs, [
            'login' => 'required|exists:users,username',
        ], [
            'login.*' => 'نام کاربری یا گذرواژه صحیح نمیباشد.',
        ])->errors();

        if ($errors->isEmpty()) {
            if (!Auth::validate([
                'username' => $request->post('login'),
                'password' => $request->post('password')
            ]))
                $errors = new MessageBag([
                    'login' => 'نام کاربری یا گذرواژه صحیح نمیباشد.'
                ]);
        }

        if ($errors->isEmpty()) {
            return response()->json([
                'ok' => true,
            ]);
        } else {
            return response()->json([
                'ok' => false,
                'errors' => $errors
            ], 400);
        }
    }

}
