<?php

namespace App\Library\FoxPaginate;

use Illuminate\Contracts\Pagination\LengthAwarePaginator;
use Illuminate\Database\Eloquent\Builder;

class TablePaginator
{
    /**
     * @param mixed $query
     * @param mixed $options
     * @return LengthAwarePaginator
     */
    public static function paginate($query, mixed $options = []): LengthAwarePaginator
    {
        $search_name = $options['search_name'] ?? 's';
        $search_value = request($search_name);
        if (!is_null($search_value) && isset($options['search_fields']) && is_array($options['search_fields'])) {
            $fields = $options['search_fields'];
            for ($i = 0; $i < count($fields); $i++) {
                $field = $fields[$i];
                if ($i === 0)
                    $query = $query->where($field, 'like', '%' . $search_value . '%');
                else
                    $query = $query->orWhere($field, 'like', '%' . $search_value . '%');
            }
        }
        return $query->paginate($options['per_page'] ?? 10, $options['columns'] ?? ["*"], $options['page_name'] ?? 'page');
    }
}
