<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Jenssegers\Mongodb\Eloquent\Model;
use Jenssegers\Mongodb\Relations\BelongsTo;
use Jenssegers\Mongodb\Relations\BelongsToMany;

class Channel extends Model
{
    use HasFactory;

    public $incrementing = false;

    protected $fillable = [
        '_id',
        'access_hash',
        'title'
    ];

    protected $hidden = [
        'bot_ids'
    ];

    public function bots(): BelongsToMany
    {
        return $this->belongsToMany(Bot::class);
    }
}
