<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Jenssegers\Mongodb\Eloquent\Model;
use Jenssegers\Mongodb\Relations\BelongsTo;

class Operation extends Model
{
    use HasFactory;

    protected $fillable = [
        'user_id',
        'bot_id',
        'src_id',
        'dest_id',
        'archive_id',
        'title',
        'rules',
        'enabled'
    ];

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    public function bot(): BelongsTo
    {
        return $this->belongsTo(Bot::class);
    }

    public function src(): BelongsTo
    {
        return $this->belongsTo(Channel::class, 'src_id');
    }

    public function dest(): BelongsTo
    {
        return $this->belongsTo(Channel::class, 'dest_id');
    }

    public function archive(): BelongsTo
    {
        return $this->belongsTo(Channel::class, 'archive_id');
    }
}
